//! # bindings for gtk part of libdbusmenu
//!
//! Rust bindings for the gtk part of [libdbusmenu] that work with the [gtk-rs ecosystem].
//!
//! If you are looking to expose a menu over DBus (e.g. for a system tray icon), see [`mod@dbusmenu_glib`].
//! This crate provides [`Menu`], a GTK widget which will show the contents of a menu exposed over DBus.
//!
//! [libdbusmenu]: https://github.com/AyatanaIndicators/libdbusmenu
//! [gtk-rs ecosystem]: https://gtk-rs.org

// for links in docs
#[allow(unused)] use dbusmenu_glib;
#[allow(unused)] use gtk;
#[allow(unused_macros)]
#[doc(hidden)]
macro_rules! skip_assert_initialized {
    () => {};
}

#[allow(unused_macros)]
#[doc(hidden)]
macro_rules! assert_initialized_main_thread {
    () => {
      if !::gtk::is_initialized_main_thread() {
    if ::gtk::is_initialized() {
        panic!("GTK may only be used from the main thread.");
    } else {
        panic!("GTK has not been initialized. Call `gtk::init` first.");
    }
}

    };
}

mod auto;
pub use auto::*;
pub use ffi;
